/* Sistemas Integrados TEKNISA                                                
   Compras e Suprimentos                                                      

Nome: 8810_SUPSTPO.sql

Descrio: 
Atualiza o custo da AF na tabela CUSTOSUP.
                                                                            
Criao:                                                                   
29/06/2004 Joo Fernando                                              
*/

IF EXISTS (SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'CUSTO_AF'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)
   DROP PROCEDURE CUSTO_AF;
GO

CREATE PROCEDURE CUSTO_AF
   @P_CDFILDEST   VARCHAR(4),
   @P_CDFILLANC   VARCHAR(4),
   @P_NRAUTOFORN  VARCHAR(10),
   @P_NRSEQAPURAF VARCHAR(10)

AS
   DECLARE @V_COUNT        NUMERIC;
   DECLARE @V_VRPRCUSAFM1  FLOAT;
   DECLARE @V_VRPRCUSAFM2  FLOAT;
   DECLARE @V_IDUTTPCUSTO  VARCHAR(1);
   DECLARE @V_IDUTTPCUSTO1 VARCHAR(1);
   DECLARE @V_IDUTTPCUSTO2 VARCHAR(1);
   DECLARE @V_IDUTTPCUSTO3 VARCHAR(1);

   DECLARE @V_CUSTOAF_CDFILDEST   VARCHAR(4);
   DECLARE @V_CUSTOAF_DTPROGENTAF DATETIME;
   DECLARE @V_CUSTOAF_CDPRODESTO  VARCHAR(10);
   DECLARE @V_CUSTOAF_VRMINPRECO  FLOAT;
   DECLARE @V_CDFORNECED   VARCHAR(21);
   DECLARE @V_CDPRODCOMPRA VARCHAR(10);
BEGIN
   SET @V_VRPRCUSAFM1 = NULL;
   SET @V_VRPRCUSAFM2 = NULL;

   SELECT @V_IDUTTPCUSTO = MAX(IDUTTPCUSTO)
   FROM TIPOCUSTO
   WHERE CDTIPOCUSTO = '07';

   SELECT @V_IDUTTPCUSTO1 = MAX(IDUTTPCUSTO)
   FROM TIPOCUSTO
   WHERE CDTIPOCUSTO = '32';

   SELECT @V_IDUTTPCUSTO2 = MAX(IDUTTPCUSTO)
   FROM TIPOCUSTO
   WHERE CDTIPOCUSTO = '33';

   SELECT @V_IDUTTPCUSTO3 = MAX(IDUTTPCUSTO)
   FROM TIPOCUSTO
   WHERE CDTIPOCUSTO = '45';

   IF (@V_IDUTTPCUSTO = 'S') OR (@V_IDUTTPCUSTO1 = 'S') OR (@V_IDUTTPCUSTO2 = 'S') OR (@V_IDUTTPCUSTO3 = 'S') BEGIN
      DECLARE C_CUSTOAF CURSOR FOR
          SELECT
             ITEMAUTF.CDFILDEST,
             ITEMAUTF.DTPROGENTAF,
             PRODUTO.CDPRODESTO,
             MIN(ITEMAUTF.VRPREUNIAF/PRODUTO.VRFATOCONV) AS VRMINPRECO
          FROM
             PARAMGERAL,
             PRODUTO,
             (SELECT
                 CDFILDEST,
                 CDFILLANC,
                 NRAUTOFORN,
                 CDFORNECED
              FROM
                 AUTOFORNE
              WHERE
                 CDFILDEST = @P_CDFILDEST AND
                 CDFILLANC = @P_CDFILLANC AND
                 NRAUTOFORN = @P_NRAUTOFORN
              UNION ALL
              SELECT
                 CDFILDEST,
                 CDFILLANC,
                 NRAUTOFORN,
                 CDFORNECED
              FROM
                 AUTOFORNE
              WHERE
                 CDFILLANC = @P_CDFILLANC AND
                 NRSEQAPURAF = @P_NRSEQAPURAF) AUTOFORNE,
             ITEMAUTF
          WHERE
             ITEMAUTF.CDFILLANC  = AUTOFORNE.CDFILLANC  AND
             ITEMAUTF.CDFILDEST  = AUTOFORNE.CDFILDEST  AND
             ITEMAUTF.NRAUTOFORN = AUTOFORNE.NRAUTOFORN AND
             PRODUTO.CDPRODUTO   = ITEMAUTF.CDPRODUTO AND
             NOT EXISTS
               (SELECT
                  CDFORNECED
                FROM
                  REFORFIL
                WHERE
                  CDFILIAL   = AUTOFORNE.CDFILDEST   AND
                  CDFORNECED = AUTOFORNE.CDFORNECED AND
                  CDPERIENTR IS NULL)  AND
             (
              (EXISTS (SELECT
                          CDMARCA
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL  = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO = ITEMAUTF.CDPRODUTO) AND
                          (CDTIPPART = '1')                   AND
                          (CDMARCA   = ITEMAUTF.CDMARCA))         ) OR
              (EXISTS (SELECT
                          CDMARCA
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL  = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO = ITEMAUTF.CDPRODUTO) AND
                          (CDTIPPART = '2')                   AND
                          (CDMARCA   = ITEMAUTF.CDMARCA))         ) OR
              (EXISTS (SELECT
                          CDFORNECED
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO  = ITEMAUTF.CDPRODUTO) AND
                          (CDTIPPART  = '4')                   AND
                          (CDFORNECED = AUTOFORNE.CDFORNECED))     ) OR
              (EXISTS (SELECT
                          CDFORNECED
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO  = ITEMAUTF.CDPRODUTO) AND
                          (CDTIPPART  = '5')                   AND
                          (CDFORNECED = AUTOFORNE.CDFORNECED))     ) OR
              (EXISTS (SELECT
                          CDFORNECED
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO  = ITEMAUTF.CDPRODUTO) AND
                          (CDTIPPART  = '7')                   AND
                          (CDMARCA    = ITEMAUTF.CDMARCA)      AND
                          (CDFORNECED = AUTOFORNE.CDFORNECED))     ) OR
              (EXISTS (SELECT
                          CDFORNECED
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO  = ITEMAUTF.CDPRODUTO) AND
                          (CDTIPPART  = '8')                   AND
                          (CDMARCA    = ITEMAUTF.CDMARCA)      AND
                          (CDFORNECED = AUTOFORNE.CDFORNECED))     ) OR
              (EXISTS (SELECT
                          CDPRODUTO
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO  = ITEMAUTF.CDPRODUTO) AND
                          (CDTIPPART  IN ('3','6','9')))    ) OR
              (NOT EXISTS (SELECT
                          CDPRODUTO
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO  = ITEMAUTF.CDPRODUTO))    )
             ) AND
               (NOT EXISTS (SELECT
                               CDMARCA
                            FROM
                               PARTFILI
                            WHERE
                               (CDFILIAL  = ITEMAUTF.CDFILDEST)           AND
                               (CDPRODUTO = ITEMAUTF.CDPRODUTO) AND
                               (CDTIPPART = '3')                   AND
                               (CDMARCA   = ITEMAUTF.CDMARCA))         )   AND
               (NOT EXISTS (SELECT
                               CDFORNECED
                            FROM
                               PARTFILI
                            WHERE
                               (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                               (CDPRODUTO  = ITEMAUTF.CDPRODUTO) AND
                               (CDTIPPART  = '6')                   AND
                               (CDFORNECED = AUTOFORNE.CDFORNECED))     )   AND
               (NOT EXISTS (SELECT
                               CDFORNECED
                            FROM
                               PARTFILI
                            WHERE
                               (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                               (CDPRODUTO  = ITEMAUTF.CDPRODUTO) AND
                               (CDTIPPART  = '9')                   AND
                               (CDMARCA    = ITEMAUTF.CDMARCA)      AND
                               (CDFORNECED = AUTOFORNE.CDFORNECED))     )
          GROUP BY
             ITEMAUTF.CDFILDEST,
             ITEMAUTF.DTPROGENTAF,
             PRODUTO.CDPRODESTO;
      OPEN C_CUSTOAF;
      FETCH NEXT FROM C_CUSTOAF INTO @V_CUSTOAF_CDFILDEST,
                                     @V_CUSTOAF_DTPROGENTAF,
                                     @V_CUSTOAF_CDPRODESTO,
                                     @V_CUSTOAF_VRMINPRECO;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF @V_IDUTTPCUSTO1 = 'S' BEGIN
            SET @V_VRPRCUSAFM1 = 0;
            SELECT @V_VRPRCUSAFM1 = CASE ISNULL(MAX(MOVINDICE.VRINDICE), 0)
                                       WHEN 0 THEN 0
                                       ELSE ISNULL(@V_CUSTOAF_VRMINPRECO, 0) / ISNULL(MAX(MOVINDICE.VRINDICE), 0)
                                    END
            FROM PARAMGERAL, MOVINDICE
            WHERE PARAMGERAL.CDINDICEMF = MOVINDICE.CDINDICE AND
                  MOVINDICE.DTREFIND    = @V_CUSTOAF_DTPROGENTAF AND
                  MOVINDICE.CDTPINDICE  = '1' AND
                  MOVINDICE.IDPERVALOR  = '2';
         END;

         IF @V_IDUTTPCUSTO2 = 'S' BEGIN
            SET @V_VRPRCUSAFM2 = 0;
            SELECT @V_VRPRCUSAFM2 = CASE ISNULL(MAX(MOVINDICE.VRINDICE), 0)
                                       WHEN 0 THEN 0
                                       ELSE ISNULL(@V_CUSTOAF_VRMINPRECO, 0) / ISNULL(MAX(MOVINDICE.VRINDICE), 0)
                                    END
            FROM PARAMGERAL, MOVINDICE
            WHERE PARAMGERAL.CDINDICEMF2 = MOVINDICE.CDINDICE AND
                  MOVINDICE.DTREFIND     = @V_CUSTOAF_DTPROGENTAF AND
                  MOVINDICE.CDTPINDICE   = '1' AND
                  MOVINDICE.IDPERVALOR   = '2';
         END;
         SET @V_CDFORNECED   = NULL;
         SET @V_CDPRODCOMPRA = NULL;
         IF (@V_IDUTTPCUSTO3 = 'S') BEGIN
            SELECT
               @V_CDFORNECED   = MAX(A.CDFORNECED),
               @V_CDPRODCOMPRA = MAX(I.CDPRODUTO)
            FROM
               PRODUTO P,
               AUTOFORNE A,
               ITEMAUTF I
            WHERE
               A.CDFILDEST                 = @V_CUSTOAF_CDFILDEST                               AND
               A.CDFILLANC                 = @P_CDFILLANC                                       AND
               A.NRAUTOFORN                = ISNULL(@P_NRAUTOFORN, A.NRAUTOFORN)                AND
               ISNULL(A.NRSEQAPURAF, '')  = ISNULL(@P_NRSEQAPURAF, ISNULL(A.NRSEQAPURAF, '')) AND
               A.CDFILDEST                 = I.CDFILDEST                                        AND
               A.CDFILLANC                 = I.CDFILLANC                                        AND
               A.NRAUTOFORN                = I.NRAUTOFORN                                       AND
               I.DTPROGENTAF               = @V_CUSTOAF_DTPROGENTAF                             AND
               P.CDPRODESTO                = @V_CUSTOAF_CDPRODESTO                              AND
               P.CDPRODUTO                 = I.CDPRODUTO                                        AND
               (I.VRPREUNIAF/P.VRFATOCONV) = @V_CUSTOAF_VRMINPRECO;
         END;

         SET @V_COUNT = 0;
         SELECT
            @V_COUNT = COUNT(*)
         FROM
            CUSTOSUP
         WHERE
            CDFILIAL = @V_CUSTOAF_CDFILDEST AND
            CDPRODUTO = @V_CUSTOAF_CDPRODESTO AND
            DTCUSTOSUP = @V_CUSTOAF_DTPROGENTAF;
         IF @V_COUNT > 0 BEGIN
            UPDATE CUSTOSUP
            SET VRPRCUSTOAF = CASE @V_IDUTTPCUSTO WHEN 'S' THEN @V_CUSTOAF_VRMINPRECO END,
                VRPRCUSAFM1  = @V_VRPRCUSAFM1,
                VRPRCUSAFM2  = @V_VRPRCUSAFM2,
                CDPRODCUSTAF = @V_CDPRODCOMPRA,
                CDFORNCUSTAF = @V_CDFORNECED
            WHERE
               CDFILIAL = @V_CUSTOAF_CDFILDEST AND
               CDPRODUTO = @V_CUSTOAF_CDPRODESTO AND
               DTCUSTOSUP = @V_CUSTOAF_DTPROGENTAF;
         END
         ELSE BEGIN
            INSERT INTO CUSTOSUP
               (CDFILIAL, CDPRODUTO, DTCUSTOSUP,
                VRPRCUSTOAF, VRPRCUSAFM1, VRPRCUSAFM2, CDPRODCUSTAF, CDFORNCUSTAF)
            VALUES
               (@V_CUSTOAF_CDFILDEST, @V_CUSTOAF_CDPRODESTO, @V_CUSTOAF_DTPROGENTAF,
                CASE @V_IDUTTPCUSTO WHEN 'S' THEN @V_CUSTOAF_VRMINPRECO END, @V_VRPRCUSAFM1, @V_VRPRCUSAFM2,
                @V_CDPRODCOMPRA, @V_CDFORNECED);
         END;
         FETCH NEXT FROM C_CUSTOAF INTO @V_CUSTOAF_CDFILDEST,
                                        @V_CUSTOAF_DTPROGENTAF,
                                        @V_CUSTOAF_CDPRODESTO,
                                        @V_CUSTOAF_VRMINPRECO;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CUSTO_AF','4.11.017';
GO

