function CMP03905ImportacaoSolicitacaoComprasController(CMP03905ImportacaoSolicitacaoComprasService, Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller, metaDataFactory, $http, General, Utilities, ScreenService, templateManager, MessageService, ZHPromise) {
    /**********
     * Filtro *
     **********/
    
    this.onEnterOnceImportacaoSolicitacaoCompras = function(widget) {
        Utilities.startFilter(widget);
    };
    
    function skipZeedhiFilterApply(args) {
        args.e.preference.CUSTOM_FILTER_ROW = {};
    }
    
    this.beforeFilterApply = function(args) {
        const filterRow = args.e.preference.FILTER_ROW;
        const widgetGrid = templateManager.container.getWidget('cmp03905_grid');
        
        skipZeedhiFilterApply(args);
        
        // if(!widget.SENHA_GERENTE) {
        //     return ScreenService.showMessage("Senha inválida!");
        // }
        
        widgetGrid.dataSourceFilter = [
            {
                name: 'P_CDFILIAL',
                operator: '=',
                value: filterRow.CDFILIAL,
            },
            {
                name: 'P_LISTAPRECO',
                operator: '=',
                value: '',
            },
            {
                name: 'P_CUSTOZERO',
                operator: '=',
                value: filterRow.CUSTOZERO,
            },
            {
                name: 'P_NRTIPCUST',
                operator: '=',
                value: filterRow.CDTIPOCUSTO,
            },
            {
                name: 'P_CDFORNECED',
                operator: '=',
                value: filterRow.CDFORNECED,
            },
            {
                name: 'P_NRSOLICMP',
                operator: '=',
                value: filterRow.NRSOLICMP,
            },
            {
                name: 'P_CARREGAJAIMP',
                operator: '=',
                value: filterRow.CARREGAJAIMP,
            },
            {
                name: 'P_CDOPERADOR',
                operator: '=',
                value: filterRow.CDOPERADOR,
            },
            {
                name: 'NRORG',
                operator: '=',
                value: getLocalVar('NRORG'),
            }
        ];
    };
    
    this.afterFilterApply = function(widget) {
        widget.floatingControl.refreshAction = true;
        if (widget.dataSource.data.length) {
            if(widget.dataSource.data[0].CDMARCA == null){
                MessageService.showMessageByCode("MARCA_NOT_REGISTERED", null, Constants.errorMessage).then(function(){
                    widget.dataSource.data = [];	
                });
            }
        }
    };
    
    this.habilitaFieldNumeroSolicitacao = function(fieldUnidadeDestino) {
        const widget = fieldUnidadeDestino.widget;
        const fieldNumeroSolicitacao = widget.getField('NRSOLICMP_FILTRO');
        
        if (fieldUnidadeDestino.value()) {
            const checkboxCarregaSolicitacoesJaImportadas = widget.getField('CARREGAJAIMP');
            
            fieldNumeroSolicitacao.readOnly = false;
            fieldNumeroSolicitacao.dataSourceFilter = [
                {
                    name: 'P_CDFILIAL',
                    operator: '=',
                    value: widget.currentRow.CDFILIAL
                },
                {
                    name: 'P_NRSOLICMP',
                    operator: '=',
                    value: ''
                },
                {
                    name: 'P_CARREGAJAIMP',
                    operator: '=',
                    value: checkboxCarregaSolicitacoesJaImportadas.value()
                },
                {
                    name: 'P_CDFORNECED',
                    operator: '=',
                    value: widget.currentRow.CDFORNECED
                }
            ];
        } else {
            fieldNumeroSolicitacao.readOnly = true;
            fieldNumeroSolicitacao.clearValue();
        }
    };
    
    
    /********
     * Grid *
     ********/  
    this.voltarParaLancamentoAF = function() {
        $http.get('assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/json/containers/cmp03900_lancamento_autorizacao_de_fornecimento.json').then(function(response) {
            const containerLancamentoAF = this.containerFactory(response.data);
            
            Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller.containerAF = containerLancamentoAF;
            templateManager.container = containerLancamentoAF;
        }.bind(metaDataFactory));
    };
    
    function verificaDtEntregaPorFornecedor() { 
        const deferred = ZHPromise.defer();
        const widgetPrincipal = templateManager.container.getWidget('cmp03905_grid');
        const checkedRows = widgetPrincipal.getCheckedRows();
        const fieldFornecedor = widgetPrincipal.getField('FORNECEDOR');
        
        if(fieldFornecedor.dataSource.data.length) {
            if(fieldFornecedor.dataSource.data[0].IDGERAFDTENT === 'S') {
                const dtEntregas = [...new Set(checkedRows.map(row => row.DTPROGENTR))];
                if(dtEntregas.length > 1) {
                    MessageService.showMessageByCode("BLOCK_DIFFERENTS_DATES", {NMFANTFORN: fieldFornecedor.dataSource.data[0].NMFANTFORN}, Constants.errorMessage);
                    return deferred.reject();
                }
            } else {
                deferred.resolve();
            }
        } else {
            return deferred.reject();
        }
        
        return deferred.promise;
    }
    
     
    this.importarParaAutorizacaoFornecimento = function(widget) {
        const filterRow = widget.appliedFilter.FILTER_ROW;
        const unidadeDestino = {
            codigo: filterRow.CDFILIAL,
            nome: filterRow.NMFILIAL,
        };
        
        if(verificaDtEntregaPorFornecedor()) {
            $http.get('assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/json/containers/cmp03900_lancamento_autorizacao_de_fornecimento.json').then(function(response) {
                const containerLancamentoAF = this.containerFactory(response.data);
                
                Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller.setContainer(containerLancamentoAF);
                
                const filtro     = containerLancamentoAF.getWidget('filtro');
                const qtdVolume  = containerLancamentoAF.getWidget('produtos').getField('QTVOLUITEMAF').isVisible;
                const inconsAF   = containerLancamentoAF.getWidget('inconsistencias').getAction('ignorarInconsistencia').isVisible;
                
        		$http.get('assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/json/containers/cmp03900_adicao_autorizacao_de_fornecimento.json').then(function(result) {
        			const containerAdicaoAF = this.containerFactory(result.data);
        			
        			templateManager.container = containerAdicaoAF;
        			
        			const tabAdicao = templateManager.container.getWidget('tab_adicao');
        			
        			const itens = widget.getCheckedRows().map(row => {
        			    row.QTESTOQUE = General.valueToFloat(row.QTESTOQUE);
        			    row.QTSOLIPROD = General.valueToFloat(row.QTSOLIPROD);
        			    row.VRCUSTO = General.valueToFloat(row.VRCUSTO);
        			    row.IDITMIPORT = true;
        			    
        			    return row;
        			});
        			
        			containerAdicaoAF.isImportacao = true;
        			containerAdicaoAF.dadosImportacao = {
        			    NMRAZSOCFORN: filterRow.NMRAZSOCFORN,
                        CDFORNECED: filterRow.CDFORNECED,
                        IDGERAFDTENT: filterRow.IDGERAFDTENT,
                        CDOPERADOR: filterRow.CDOPERADOR,
                        NMOPERADOR: filterRow.NMOPERADOR,
                        itens
        			};
        			
        			Cmp03900_LancamentoAutorizacaoDeFornecimento_Controller.onEnterAdicao({
        			    widget: tabAdicao,
        			    filtro,
        			    qtdVolume,
        			    unidadeDestino,
        			    inconsAF,
        			    isOnEnterEvent: true,
        			});
        		}.bind(this), function(error) {
        			throw error;
        		});
            }.bind(metaDataFactory));
        }
    };
    
    this.verificaCusto = function(args) {
        const widgetGrid = templateManager.container.getWidget('cmp03905_grid');
        
        if(widgetGrid.editing) {
        	args.e.preventDefault();
        }
        
        if(parseFloat(args.selectedRow.QTSOLIPROD) == 0){
            MessageService.showMessageByCode("INFORMAR_QTDE", null, Constants.errorMessage);
            args.e.preventDefault();   
        }
        
        if(parseFloat(args.selectedRow.VRCUSTO) == 0){
            MessageService.showMessageByCode("INFORMAR_CUSTO", null, Constants.errorMessage);
            args.e.preventDefault();   
        }
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('CMP03905ImportacaoSolicitacaoComprasController', CMP03905ImportacaoSolicitacaoComprasController);
});